package oop6_dat6_u;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class SolidFileIO
{

    private static int number;

    public static Cube[] readSolids(String fileName)
    {
        ArrayList<Cube> list = new ArrayList<Cube>();

        try {
            FileReader aFileReader = new FileReader(fileName);
            BufferedReader aBufferedReader = new BufferedReader(aFileReader);

            String line = aBufferedReader.readLine();
            StringTokenizer sT;
            while (line != null) { // while not EOF
                sT = new StringTokenizer(line, "C: ");
                int s1 = Integer.parseInt(sT.nextToken());
                int s2 = Integer.parseInt(sT.nextToken());
                int s3 = Integer.parseInt(sT.nextToken());
                //aufsteigend sortieren s1, s2, s3
                int sTemp;
                if (s1 > s2) {
                    sTemp = s1;
                    s1 = s2;
                    s2 = sTemp;
                }
                if (s1 > s3) {
                    sTemp = s1;
                    s1 = s3;
                    s3 = sTemp;
                }
                if (s2 > s3) {
                    sTemp = s2;
                    s2 = s3;
                    s3 = sTemp;
                }
                list.add(new Cube(number, s1, s2, s3));
                number ++;
                line = aBufferedReader.readLine();
            }
            aFileReader.close();

        } catch (FileNotFoundException ex) {
            System.out.println("ERROR:");
            ex.printStackTrace();
        } catch (IOException ex) {
            System.out.println("ERROR:");
            ex.printStackTrace();
        } finally {
            return list.toArray(new Cube[1]); // siehe auch API-Dokumentation
        }

    }


    /**
     * mini Test
     * @param args
     */
    public static void main(String[] args)
    {
        SolidFileIO a = new SolidFileIO();
        Cube[] c = a.readSolids("soliddata.txt");
        for (Cube cube : c) {
            System.out.println(cube.toString());
        }

    }
}
